summaryrefslogtreecommitdiffstats
path: root/icecast
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2010-09-16 15:48:15 +0000
committer Eric Hameleers <alien@slackware.com>2010-09-16 15:48:15 +0000
commit06e94860aca71ad005eb1084231dbb1c2af7fde0 (patch)
tree230ec468f87e9c251a75c43aa43f3ed394e2258f /icecast
parentabb9d76c46f7f7327d027a8fe6209371c6a21158 (diff)
downloadasb-06e94860aca71ad005eb1084231dbb1c2af7fde0.tar.gz
asb-06e94860aca71ad005eb1084231dbb1c2af7fde0.tar.xz
Fixup the script
Diffstat (limited to 'icecast')
-rwxr-xr-xicecast/build/ices.SlackBuild353
-rwxr-xr-xicecast/build/libshout.SlackBuild2
2 files changed, 221 insertions, 134 deletions
diff --git a/icecast/build/ices.SlackBuild b/icecast/build/ices.SlackBuild
index 6098368d..6f39d23c 100755
--- a/icecast/build/ices.SlackBuild
+++ b/icecast/build/ices.SlackBuild
@@ -1,125 +1,205 @@
#!/bin/sh
# $Id$
-# Copyright (c) 2006 Eric Hameleers <alien@slackware.com>
-# Distributed under the terms of the GNU General Public License, Version 2
-# ---------------------------------------------------------------------------
-# Slackware SlackBuild script
+# Copyright 2004,2005,2010 Eric Hameleers, Eindhoven, NL
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
# ===========================
-# By: Eric Hameleers <alien@slackware.com>
-# For: IceS
-# URL: http://www.icecast.org/
-# Summary: An mp3 source client for the icecast streaming media server
-# Needs: libvorbis, libogg, libxml2, libshout2, lame, perl, python
+# By: Eric Hameleers <alien@slackware.com>
+# For: ices
+# Descr: mp3 source client for the icecast streaming media server
+# URL: http://icecast.org/
+# Needs: faad2, libshout2, lame
# Changelog:
-# 0.4-1: 20/oct/2004 by Eric Hameleers
-# Initial build.
-# 0.4-2: 11/mar/2006 by Eric Hameleers
-# Added logrotate script.
-#
-# --------------------------------------------------------------------------
+# 0.4-1: 20/oct/2004 by Eric Hameleers
+# * Initial build.
+# 0.4-2: 11/mar/2006 by Eric Hameleers
+# * Added logrotate script.
+# 0.4-3: 16/Sep/2010 by Eric Hameleers <alien@slackware.com>
+# * Rebuilt for Slackware 13.1
+#
+# Run 'sh ices.SlackBuild' to build a Slackware package.
+# The package (.tgz) and .txt file as well as build logs are created in /tmp .
+# Install it using 'installpkg'.
#
+# -----------------------------------------------------------------------------
+
# Set initial variables:
-CWD=`pwd`
-if [ "$TMP" = "" ]; then
- TMP=/tmp
-fi
PRGNAM=ices
-VERSION=0.4
-ARCH=i486
-BUILD=2
+VERSION=${VERSION:-0.4}
+BUILD=${BUILD:-3}
+NUMJOBS=${NUMJOBS:" -j4 "}
+TAG=${TAG:-alien}
-PKG=$TMP/package-$PRGNAM
+# Icecast and ices will run as this user:
+iceuser=icecast
+icegroup=icecast
-if [ ! -d $TMP/tmp-$PRGNAM ]; then
- mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+SRCURL="http://downloads.us.xiph.org/releases/${PRGNAM}/${PRGNAM}-${VERSION}.tar.gz"
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Automatically determine the architecture we're building on:
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) export ARCH=i486 ;;
+ arm*) export ARCH=arm ;;
+ # Unless $ARCH is already set, use uname -m for all other archs:
+ *) export ARCH=$( uname -m ) ;;
+ esac
fi
-if [ ! -d $PKG ]; then
- mkdir -p $PKG # place for the package to be built
+
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ *) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line ${LINENO}" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Save old umask and set to 0022:
+_UMASK_=$(umask)
+umask 0022
+
+# Create working directories:
+mkdir -p $OUTPUT # place for the package to be saved
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # always erase old package's contents
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+rm -rf $OUTPUT/{configure,make,install,error,makepkg}-$PRGNAM.log
+ # remove old log files
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/$(basename $SOURCE)"
+ echo "Source '$(basename ${SOURCE})' not available yet..."
+ echo "Will download file to $(dirname $SOURCE)"
+ wget -nv -T 20 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '$(basename ${SOURCE})' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '$(basename ${SOURCE})' not available... aborting the build."
+ exit 1
+ fi
fi
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
# --- PACKAGE BUILDING ---
-echo "+==============+"
-echo "| $PRGNAM-$VERSION |"
-echo "+==============+"
-
-iceuser=icecast
-icegroup=icecast
-
-rm -rf $PKG/*
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
# Explode the package framework:
-cd $PKG
-if [ -f $CWD/_$PRGNAM.tar.gz ]; then
- explodepkg $CWD/_$PRGNAM.tar.gz
+if [ -f $SRCDIR/_$PRGNAM.tar.gz ]; then
+ cd $PKG
+ explodepkg $SRCDIR/_$PRGNAM.tar.gz
+ cd -
fi
cd $TMP/tmp-$PRGNAM
-
-# Extract tar ball in TEMP dir
-echo Building $PRGNAM...
-tar -zxvpf $CWD/$PRGNAM-$VERSION.tar.gz
-cd $PRGNAM-$VERSION
-./configure --prefix=/usr --localstatedir=/var \
- --sysconfdir=/usr/share/icecast/etc \
- --with-moddir=/usr/share/icecast/etc/modules \
- --with-perl --with-python \
- --with-lame --with-vorbis \
- 2>&1 | tee $CWD/configure-${PRGNAM}.log
-make | tee $CWD/make-${PRGNAM}.log
-
-# Install all the needed stuff to the package dir
-# Use installwatch if available:
-which installwatch > /dev/null 2>&1
-if [ $? == 0 ]; then
- installwatch -o $CWD/install-${PRGNAM}.log \
- make prefix=$PKG/usr \
- localstatedir=$PKG/var \
- sysconfdir=$PKG/usr/share/icecast/etc \
- moddir=$PKG/usr/share/icecast/etc/modules \
- install
-else
- make prefix=$PKG/usr \
- localstatedir=$PKG/var \
- sysconfdir=$PKG/usr/share/icecast/etc \
- moddir=$PKG/usr/share/icecast/etc/modules \
- install \
- 2>&1 | tee $CWD/install-${PRGNAM}.log
-fi
-
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a+X-s .
+
+echo Building ...
+LDFLAGS="$SLKLDFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --localstatedir=/var \
+ --sysconfdir=/etc/icecast \
+ --with-moddir=/usr/share/icecast/modules \
+ --with-docdir=/usr/doc/$PRGNAM-$VERSION \
+ --with-perl --with-python \
+ --with-lame --with-vorbis \
+ --program-prefix= \
+ --program-suffix= \
+ --build=$ARCH-slackware-linux \
+ 2>&1 | tee $OUTPUT/configure-${PRGNAM}.log
+
+make $NUMJOBS 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+make install \
+ prefix=$PKG/usr \
+ localstatedir=$PKG/var \
+ sysconfdir=$PKG/etc/icecast \
+ docdir=$PKG/usr/doc/$PRGNAM-$VERSION \
+ moddir=$PKG/usr/share/icecast/modules \
+ 2>&1 | tee $OUTPUT/install-${PRGNAM}.log
+
+# Create the ices state directory:
mkdir -p $PKG/var/state/ices
-(cd $PKG/usr/share/icecast/etc && patch < $CWD/ices_conf.patch)
-# (cd $PKG/usr && ln -s /usr/share/icecast ices)
+( cd $PKG/etc/icecast && patch -p0 --verbose < $SRCDIR/ices_conf.patch )
-# --- DOCUMENTATION ---
-
-# Compress the man page
-gzip -9 $PKG/usr/man/*/*
-
-# Copy the documentation
-mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
-mv $PKG/usr/doc/ices/icesmanual.html $PKG/usr/doc/$PRGNAM-$VERSION/
-rm -r $PKG/usr/doc/ices
-chmod -R -w $PKG/usr/doc/$PRGNAM-$VERSION
-
-
-# --- POST-INSTALL SCRIPT ---
-
-# --- Fabricate the 'doinst.sh' script: ------
-mkdir -p $PKG/install
-
-cat <<EOINS > $PKG/install/doinst.sh
+# Add this to the doinst.sh:
+! [ -d $PKG/install ] && mkdir -p $PKG/install
+cat <<EOINS >> $PKG/install/doinst.sh
# Handle the incoming configuration files:
config() {
for infile in \$1; do
NEW="\$infile"
- OLD="\`dirname \$NEW\`/\`basename \$NEW .new\`"
+ OLD="\$(dirname \$NEW)/\$(basename \$NEW .new)"
# If there's no config file by that name, mv it over:
if [ ! -r \$OLD ]; then
mv \$NEW \$OLD
- elif [ "\`cat \$OLD | md5sum\`" = "\`cat \$NEW | md5sum\`" ]; then
+ elif [ "\$(cat \$OLD | md5sum)" = "\$(cat \$NEW | md5sum)" ]; then
# toss the redundant copy
rm \$NEW
fi
@@ -130,58 +210,65 @@ config() {
# Take care of the logrotate script
config etc/logrotate.d/ices.new
-#Add the '${icegroup}' group if it doesn't exist already
-groupadd ${icegroup} 2> /dev/null
-#Add the '${iceuser}' user if it doesn't exist already
-useradd -c "Icecast" -d /usr/share/icecast \\
- -g ${icegroup} -s "/bin/false" ${iceuser} 2> /dev/null
+# Only way to create and use the correct uid and gid on the target system,
+# is to use chroot:
+chroot . <<EOR 2>/dev/null
+# Add the '${icegroup}' group if it doesn't exist already.
+/usr/sbin/groupadd ${icegroup} 2> /dev/null
+
+# Add the '${iceuser}' user if it doesn't exist already
+/usr/sbin/useradd -c "Icecast" -d /usr/share/icecast \\
+ -g ${icegroup} -s "/bin/false" ${iceuser} 2> /dev/null
# Configure the home directory
-# (Will exist already, if icecast package is installed previously).
-mkdir -p usr/share/icecast
-chown -R ${iceuser}:${icegroup} usr/share/icecast
-chmod 750 usr/share/icecast
+# (Home directory will exist, if icecast package was installed previously).
+mkdir -p /usr/share/icecast/modules
+chown -R ${iceuser}:${icegroup} /usr/share/icecast
+chmod 750 /usr/share/icecast
+
+# Configure the configuration directory
+mkdir -p /etc/icecast
+chown -R ${iceuser}:${icegroup} /etc/icecast
+chmod 750 /etc/icecast
# Configure the state directory
-mkdir -p var/state/ices
-chown -R ${iceuser}:${icegroup} var/state/ices
-chmod 755 var/state/ices
+mkdir -p /var/state/ices
+chown -R ${iceuser}:${icegroup} /var/state/ices
+chmod 755 /var/state/ices
+EOR
EOINS
-# --- End of 'doinst.sh' script -----------
-
-
-
-# --- OWNERSHIP, RIGHTS ---
-chown -R root.root $PKG
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cat $SRCDIR/$(basename $0) > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+chown -R root:root $PKG/usr/doc/$PRGNAM-$VERSION
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in $(find $PKG/usr/man -type l -name "*.?") ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+# Strip binaries (if any):
+find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
-# --- PACKAGE DESCRIPTION ---
+# Add a package description:
mkdir -p $PKG/install
-cat $CWD/ices.slack-desc > $PKG/install/slack-desc
-
-
-# --- BUILDING ---
+cat $SRCDIR/${PRGNAM}.slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/${PRGNAM}.slack-required > $PKG/install/slack-required
-# Build the package and compute its md5 checksum:
+# Build the package:
cd $PKG
-makepkg --linkadd y --chown n $TMP/$PRGNAM-$VERSION-$ARCH-$BUILD.tgz
-(cd $TMP && md5sum $PRGNAM-$VERSION-$ARCH-$BUILD.tgz > $PRGNAM-$VERSION-$ARCH-$BUILD.tgz.md5)
-cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $TMP/$PRGNAM-$VERSION-$ARCH-$BUILD.txt
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz} > ${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.${PKGTYPE:-tgz}.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.txt
+cat $PKG/install/slack-required > $OUTPUT/${PRGNAM}-${VERSION}-${ARCH}-${BUILD}${TAG}.dep
-
+# Restore the original umask:
+umask ${_UMASK_}
-# --- CLEANUP ---
-
-# Clean up the extra stuff:
-if [ "$1" = "--cleanup" ]; then
- rm -rf $TMP/tmp-$PRGNAM
- rm -rf $PKG
-else
- echo You can check the 'installwatch' log file: $CWD/install-${PRGNAM}.log
-fi
-
-#
-# EOF
-#
diff --git a/icecast/build/libshout.SlackBuild b/icecast/build/libshout.SlackBuild
index 7b13c108..f87a44bc 100755
--- a/icecast/build/libshout.SlackBuild
+++ b/icecast/build/libshout.SlackBuild
@@ -178,7 +178,7 @@ find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF \
# Add a package description:
mkdir -p $PKG/install
-cat $SRCDIR/slack-desc > $PKG/install/slack-desc
+cat $SRCDIR/${PRGNAM}.slack-desc > $PKG/install/slack-desc
# Build the package:
cd $PKG